import java.lang.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class AlarmIndicator {

  Box top;
  JLabel alarmLabel;
  JPanel alarmView;
  Color flashColor;

  public AlarmIndicator( String label, Color f ) {
    top = new Box(BoxLayout.Y_AXIS);
    alarmLabel = new JLabel( label);
    alarmView = new JPanel();
    alarmView.setBackground( Color.lightGray );
    alarmView.setBorder( BorderFactory.createRaisedBevelBorder() );
    alarmView.setSize( 40, 50 );
    top.add( alarmLabel );
    top.add( alarmView );
    flashColor = f;
  }

  public void showAlarm() {
    new Pinger().start();
  }

  public Component getComponent() { return top; }

    // internal class to do blinking
  class Pinger extends Thread {
    Pinger() { }
    public void run() {
//       alarmBlink.setText( "!!! Pattern not forming !!!" );
      for( int i = 0; i < 10; i++ ) {
	// toggle alarm background
	if( i%2 == 0 ) alarmView.setBackground( flashColor );
	else alarmView.setBackground( Color.lightGray );
	try { sleep( 100 ); } catch( InterruptedException e ) { }
      }
//       alarmBlink.setText( "" );
      return;
    }
  }; // internal class Pinger
};

